# CSMShader

## Import

CSMShader is an addon, and must be imported explicitly, see [Installation#Addons](https://threejs.org/manual/#en/installation).

```js
import { CSMShader } from 'three/addons/csm/CSMShader.js';
```

## Properties

### .CSMShader : Object (inner, constant)

The object that holds the GLSL enhancements to enable CSM. This code is injected into the built-in material shaders by [CSM](CSM.html).

## Source

[examples/jsm/csm/CSMShader.js](https://github.com/mrdoob/three.js/blob/master/examples/jsm/csm/CSMShader.js)